---
- name: Supervisor | Ensure supervisor config paths are present.
  file:
    path: "{{ item }}"
    state: directory
    mode: 0755
    owner: root
    group: root
  loop:
    - "{{ supervisor_config_path }}"
    - "{{ supervisor_config_path }}/conf.d"

- name: Supervisor | Ensure supervisor configuration is present.
  template:
    src: supervisord.conf.j2
    dest: "{{ supervisor_config_path }}/supervisord.conf"
    mode: 0644
  notify: restart supervisor

- name: Supervisor | Ensure supervisor program configs are present.
  template:
    src: program.conf.j2
    dest: "{{ supervisor_config_path }}/conf.d/{{ item.name }}.conf"
    force: true
    owner: root
    group: root
    mode: 0644
  when: item.state|default('present') != 'absent'
  loop: "{{ supervisor_programs }}"
  notify: restart supervisor

- name: Supervisor | Ensure unwanted supervisor program configs are absent
  file:
    path: "{{ supervisor_config_path }}/conf.d/{{ item.name }}.conf"
    state: absent
  when: item.state|default('present') == 'absent'
  loop: "{{ supervisor_programs }}"
  notify: restart supervisor
